#include <stdlib.h>
#include <ctype.h>
#include "apache_driver.hh"

apache_driver::apache_driver(): htpl_driver(), static_out(0){
}

void apache_driver::start(FILE* out_, FILE* hout_) {
  out=out_; hout=hout_;  start_time = time(0);
  fprintf(out, "//The file has been generated by %s at %s", getprogname(), ctime(&start_time));
  fprintf(out, "//DO NOT EDIT!\n");
  fprintf(out, "#include <httpd.h>\n");
  fprintf(out, "#include <http_protocol.h>\n");
}

void apache_driver::finish_header() {
  //out header
  if(hout) {
    fprintf(hout, "//The file has been generated by %s at %s", getprogname(), ctime(&start_time));
    fprintf(hout, "//DO NOT EDIT!\n");
    fprintf(hout, "void %s%s(request_rec* r",funcprefix, funcname);
    if(tplargs)
      fprintf(hout, ", %s", tplargs);
    fprintf(hout, ");\n");
  }

  fprintf(out, "void %s%s(request_rec* r",funcprefix, funcname);
  if(tplargs)
    fprintf(out, ", %s", tplargs);
  fprintf(out, ") {\n");
}

void apache_driver::out_static_block(const char* text, int textlen) {
  if(!static_out)
    fprintf(out, "\tap_rwrite(\"");
  
  const char* cp = text;
  for(int i=0; i<textlen; i++, cp++) {
    char c=*cp;
    if(isprint(c) && c!= '"' && c!='\\')
      putc(c, out);
    else
      fprintf(out, "\\%03o", c);
  }
  static_out+=textlen;
}

void apache_driver::flush_static_blocks() {
  if(static_out) {
    fprintf(out, "\",%d, r);\n", static_out);
    static_out=0;
  }
}

void apache_driver::out_dynamic_block(const char* text, int textlen) {
  fprintf(out, "\tap_rvputs(r, %*s, 0);\n", textlen, text);
}

void apache_driver::out_printf_block(const char* text, int textlen) {
  fprintf(out, "\tap_rprintf(r, %*s);\n", textlen, text);
}

