#include <stdlib.h>
#include <ctype.h>
#include <time.h>

#include "ff_driver.hh"

ff_driver::ff_driver(): htpl_driver(), static_out(0){
}

void ff_driver::start(FILE* out_, FILE* hout_) {
  out=out_; hout=hout_;  start_time = time(0);
  fprintf(out, "//The file has been generated by %s at %s", getprogname(), ctime(&start_time));
  fprintf(out, "//DO NOT EDIT!\n");
  fprintf(out, "#include <chttpd.h>\n");
}

void ff_driver::finish_header() {
  //out header
  if(hout) {
    fprintf(hout, "//The file has been generated by %s at %s", getprogname(), ctime(&start_time));
    fprintf(hout, "//DO NOT EDIT!\n");
    fprintf(hout, "void %s%s(htr* r",funcprefix, funcname);
    if(tplargs)
      fprintf(hout, ", %s", tplargs);
    fprintf(hout, ");\n");
  }

  fprintf(out, "void %s%s(htr* r",funcprefix, funcname);
  if(tplargs)
    fprintf(out, ", %s", tplargs);
  fprintf(out, ") {\n");
}

void ff_driver::out_static_block(const char* text, int textlen) {
  if(!static_out)
    fprintf(out, "\tht_send_static(r, \"");
  int i;
  const char* cp = text;
  for(i=0; i<textlen; i++, cp++) {
    char c=*cp;
    if(isprint(c) && c!= '"' && c!='\\')
      putc(c, out);
    else
      fprintf(out, "\\%03o", c);
  }
  static_out+=textlen;
}

void ff_driver::flush_static_blocks() {
  if(static_out) {
    fprintf(out, "\",%d, r);\n", static_out);
    static_out=0;
  }
}

void ff_driver::out_dynamic_block(const char* text, int textlen) {
  fprintf(out, "\t{const char* o = %*s; if(o) ht_puts(r,cpstrdup(r->pool,o));}\n", textlen, text);
}

void ff_driver::out_printf_block(const char* text, int textlen) {
  fprintf(out, "\tht_printf(r,%*s);\n", textlen, text);
}


